#ifndef CoCoALibSupplement_H
#define CoCoALibSupplement_H

//   Copyright (c)  2011  Anna Bigatti

//   This file is part of the source of CoCoALib, the CoCoA Library.

//   CoCoALib is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.

//   CoCoALib is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with CoCoALib.  If not, see <http://www.gnu.org/licenses/>.

#include "CoCoA/library.H"

namespace CoCoA
{

  RingElem LPP_forC5(ConstRefRingElem f); ///< NB result belongs to owner(f)
  RingElem LM_forC5(ConstRefRingElem f);  ///< NB result belongs to owner(f)
  inline bool IsTerm_forC5(ConstRefRingElem f) { return IsMonomial(f)&&IsOne(LC(f)); }
  inline RingElem LT_forC5(ConstRefRingElem f) { return LPP_forC5(f); }  ///< NB result belongs to owner(f)
  RingElem CoeffOfTerm_forC5(ConstRefRingElem f, ConstRefRingElem t); ///< NB result belongs to CoeffRing(owner(f))
  std::vector<RingElem> coefficients_forC5(ConstRefRingElem f);  ///< NB result belongs to CoeffRing(owner(f))
  std::vector<RingElem> monomials_forC5(ConstRefRingElem f);  ///< NB result belongs to owner(f)
  std::vector<RingElem> support_forC5(ConstRefRingElem f);  ///< NB result belongs to owner(f)

  std::vector<ZZ> wdeg_forC5(ConstRefRingElem f);
  ZZ NextPrime_forC5(ZZ N);
  factorization<long> SmoothFactor_forC5(const ZZ& n, const ZZ& TrialLimit);
  QQ CpuTime_forC5();
  
  matrix NewDenseMat_forC5(const ring& R, const ZZ& NR, const ZZ& NC);
  void SetEntry_forC5(MatrixView& M, const ZZ& I, const ZZ& J, ConstRefRingElem x);
  MatrixView IdentityMat_forC5(const ring& R, const ZZ& N);
  matrix transposed_forC5(ConstMatrixView M);
  
  
}
#endif // CoCoALibSupplement_H

